pipeline {
  environment {
    registry = "ksanchez/spring-petclinic-simplilearn-v2"
    registryCredential = 'dockerjenkinscreds'
    dockerImage = ''
  }
  agent any
  tools {
    maven 'Apache Maven 3.0.5'
    jdk 'Java version: 1.8.0_312'
  } 
  stages {
    stage('Cloning Git') {
      steps {
        git 'https://gitlab.com/pokoyo.bughunter/spring-framework-petclinic-simplilearn.git'
      }
    }
    stage('Compile') {
       steps {
         sh 'mvn compile' //only compilation of the code
       }
    }
    stage('Test') {
      steps {
        sh '''
        mvn clean install
        ls
        pwd
        ''' 
        //if the code is compiled, we test and package it in its distributable format; run IT and store in local repository
      }
    }
    stage('Building Image') {
      steps{
        script {
          dockerImage = docker.build registry + ":latest"
        }
      }
    }
    stage('Deploy Image') {
      steps{
         script {
            docker.withRegistry( '', registryCredential ) {
            dockerImage.push()
          }
        }
      }
    }
    stage('Remove Unused docker image') {
      steps{
        sh "docker rmi $registry:latest"
      }
    }
  }
}
